//+------------------------------------------------------------------+
//|                                                         GGL3.mq4 |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//|                Please do not remove this header.                 |
//+------------------------------------------------------------------+
#property copyright "Aaragorn and Eaglehawk & Maji & Robert C."
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"
#property link      "http://forex.factoid.ca/forums/showthread.php?t=104"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/2840-gogetter-ea.html"
// many thanks goes to all those on the tsdforex forum and factoid forum who have encouraged us this far

int               Build = 2102;     //this helps keep track of what version users are using.
int               MagicNumber = 21326;
#include <stdlib.mqh>


//Externally Defined Variables
extern double LotIncreaseFactor = 0.2;


extern string     Main_Signal="Main Trade Signal Settings";
extern bool       UseMain_Signal=True;
extern int        MaxOpenTrade_1 = 1;        
extern double     Lots1 = 0.1;              //0.9=29700k
extern int        TakeProfit1 = 90;         //90   105     100=22904k,104=23360,  105=29700k,  106=23984,110=21664k
extern int        StopLoss1 = 16;            //16   41   47     41=21584k,45=21720k,46=21952k   47=29700k,   48=21856k,49=21672k,50=21200k,51=21200k,
extern int        MinsMultiplier1=75;        //I believe 75 hours is optimized for GPB/USD on 30mTF

extern string     MatchingSignal_1="Matching Signal 1 Settings";
extern bool       UseMS1=true;// highMatches == 0 && lowMatches == 0 //7 instances
extern int        MaxOpenTrade_5 = 1;     
extern double     Lots5 = 0.09;         
extern int        TakeProfit5 = 85;//for some reason this really impacts signal #5 when #5= H=2,L=0
extern int        StopLoss5 = 7;
extern int        MinsMultiplier5 = 18;

extern string     MatchingSignal_2="Matching Signal 2 Settings";
extern bool       UseMS2=true;// highMatches == 1 && lowMatches == 1 //6 instances
extern int        MaxOpenTrade_6 = 1;     
extern double     Lots6 = 0.6;         
extern int        TakeProfit6 = 55;
extern int        StopLoss6 = 12;
extern int        MinsMultiplier6 = 18;

extern string     MatchingSignal_3="Matching Signal 3 Settings";
extern bool       UseMS3=true;// highMatches == 2 && lowMatches == 2 //5 instances
extern int        MaxOpenTrade_7 = 1;     
extern double     Lots7 = 1;         
extern int        TakeProfit7 = 53;
extern int        StopLoss7 = 7;
extern int        MinsMultiplier7 = 18;

extern string     Use_Function_Settings="Use Mode Settings";
extern bool       TakeProfitMode = True;
extern bool       TrailingStopMode = True;  
extern bool       StopLossMode = True;
extern bool       SignalMail = False;
extern bool       EachTickMode = True;

extern string     Support_Resistance_Settings="Support Resistance Settings";
extern int        ResistanceBarsBack = 145;
extern int        SupportBarsBack = 145;
extern int        HStartBack = 1;
extern int        LStartBack = 1;

extern string     Main_Moving_Aves_etc="Moving Average and Initial Order Settings";
extern int        ShortemaS = 4;
extern int        ShortemaL = 18;
extern int        Mtrendema = 150;
extern int        TrailingStop = 12;
extern int        Slippage = 3;
extern int        Shift = 2; //number of previous candles to look back when comparing with current bar

//internal variables
bool              LowTrailingStopTrigger = False;
double            stoptrailgap = 0; //an expirement
int               TradeSignal = 0;
int               BarCount, Current;
double            Lots = 0.08;
int               TakeProfit = 90;
int               StopLoss = 16;
int               MaxOpenTrade = 0;
bool              TickCheck = False;

#define SIGNAL_NONE 0
#define SIGNAL_BUY  1
#define SIGNAL_CLOSEBUY 3
#include <GoGetterfunctions.mqh>
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() 
{
    BarCount = Bars;

    if (EachTickMode) Current = 0; else Current = 1;

    return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() 
{
    return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{

    int Order = SIGNAL_NONE;
    int Total = OrdersTotal(), Ticket = 0;
    double StopLossLevel = 0, TakeProfitLevel = 0, equity=0, ILots=0;
    string Text;   
    bool PlaceOrder = True; 


    //Order comment-----------------------------------------------------------------   
    //Text="GGLrewrite Build "+Build;      
    //Comment("GGLrewrite build ", Build, "....Server time is ",TimeToStr(CurTime( )),);
    if (EachTickMode && Bars != BarCount) TickCheck = False;
    Order = SIGNAL_NONE;


    //+------------------------------------------------------------------+
    //| Variable Begin                                                   |
    //+------------------------------------------------------------------+
    double Buy1_1 = iMA(NULL, 0, ShortemaL, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
    double Buy1_2 = iMA(NULL, 0, ShortemaS, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
    double CloseBuy1_2 = iMA(NULL, 0, Mtrendema, 0, MODE_EMA, PRICE_CLOSE, Current + 0);

    //support and resistance
    double HIGH = High[Highest (NULL, 0, MODE_HIGH, ResistanceBarsBack, HStartBack)];
    double LOW = Low[Lowest (NULL, 0, MODE_LOW, SupportBarsBack, LStartBack)];

//+-----------------signal placement locator-----------------+
//----locates the relationship of the buy signal to the highest high and in relationship to other buy signals within specified period-----
    int h, j=-1;
    for(h=1;h<=ResistanceBarsBack;h++)
    {
	if(HIGH == High[h]) j=h;//  j=# of bars back from signal that the Highest high occurred
    }  
    int l, k=-1;
    for(l=1;l<=SupportBarsBack;l++)
    {
	if(LOW == Low[l]) k=l;//  k=# of bars back from signal that the Lowest low occurred
    } 
//+----------end signal placement locator-------------------------+ 

//Check position

    for (int i = 0; i < Total; i ++) 
    {
	OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
	if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol() && OrderMagicNumber()==MagicNumber) 
	{

	    if(OrderType() == OP_BUY) 
	    {   
		//Close
		//+------------------------------------------------------------------+
		//| Signal Begin(Exit Buy)Closing logic for long positions           |
		//+------------------------------------------------------------------+
		CloseOrder();//close on time function                
		//+------------------------------------------------------------------+
		//| Signal End(Exit Buy)                                             |
		//+------------------------------------------------------------------+

		if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
		{
		    OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, DarkOrange);
	            LowTrailingStopTrigger = False;  
		    if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
		    if (!EachTickMode) BarCount = Bars;

		    continue;
		}
		//Call Trailing stop for long position
		if (TrailingStopMode) ModifyTrades();
		if (!EachTickMode) BarCount = Bars;
		continue;
	    }
	}
    }
    //+------------------------------------------------------------------+
    //| Signal Begin(Entry logics)                                       |
    //+------------------------------------------------------------------+
    if (UseMain_Signal==True && Buy1_1 < Buy1_2 && CloseBuy1_2 < Buy1_1) 
    {
	Order=SIGNAL_BUY; 
	TradeSignal=1;
    }
    //+------------------------------------------------------------------+
    //| Signal End                                                       |
    //+------------------------------------------------------------------+ 


//Buy 
    if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
    {
	//Check free margin
	/* if (AccountFreeMargin() < (1000 * Lots)) 
	   {
	   Print("Insufficient Margin to Open Position. Free Margin = ", AccountFreeMargin());
	   return(0);
	   }  */ 
//+-------------matching to previous trade high and lows--------------------+
	int lowMatches = 0; 
	int highMatches = 0;

	for(int p = 0; p < SLSIZE; p++ ) 
	{    
	    if ( sLocatorLows[p] == LOW ) 
	    { 
		lowMatches++; 
	    }      
	    if ( sLocatorHighs[p] == HIGH ) 
	    { 
		highMatches++;
	    } 
	} 
	//Print(ResistanceBarsBack," bars back resistance:",HIGH," @ bar",j," with ",highMatches," Match(es)");
	//Print(SupportBarsBack," bars back support:",LOW," @ bar",k,"        with ",lowMatches," Match(es)");
	//Print("space");
//+----------------end of signal matching--------------------------------------------------------------+ 

//+----------Trade Signal Identification---------------------+
	bool FirstSignal = True;
	PlaceOrder = True;
	for (int m = 0; m < MaxOpenTrade; m ++)
	{ 
	    if(CountTrades() < MaxOpenTrade) 
	    {  
		if(UseMain_Signal==True)
		{  
		    TradeSignal = 1;// Matching signal #1
		    if(FirstSignal==True)
		    {
		//	Print("MainSignal High = ",highMatches,"   Low = ",lowMatches," Initial Lots=",Lots,"  Order NUMBER: ",OrderTicket()+1);
			FirstSignal=False;
			if(UseMain_Signal==False) PlaceOrder = False;
		    }
		} 
		if(UseMS1==True && highMatches == 0 && lowMatches == 0)
		{  
		    TradeSignal = 5;// Matching signal #1
		    if(FirstSignal==True)
		    {
		//	Print("Matching #1 High = ",highMatches,"   Low = ",lowMatches," Initial Lots=",Lots,"  Order NUMBER: ",OrderTicket()+1);
			FirstSignal=False;
			if(UseMS1==False) PlaceOrder = False;
		    }  
		}      
		if(UseMS2==True && highMatches == 1 && lowMatches == 1)
		{
		    TradeSignal = 6; //Mathcing Signal #2
		    if(FirstSignal==True)
		    {
		//	Print("Matching #2 High = ",highMatches,"   Low = ",lowMatches," Initial Lots=",Lots,"  Order NUMBER: ",OrderTicket()+1);
			FirstSignal=False;
			if(UseMS2==False) PlaceOrder = False;
		    } 
		}
		if(UseMS3==True && highMatches == 2 && lowMatches == 2)
		{
		    TradeSignal = 7;//Mathcing Signal #3 
		    if(FirstSignal==True)
		    {
		//	Print("Matching #3 High = ",highMatches,"   Low = ",lowMatches," Initial Lots=",Lots,"  Order NUMBER: ",OrderTicket()+1);
			FirstSignal=False;
			if(UseMS3==False) PlaceOrder = False;
		    }  
		} 
	    } 
	}       
//+----------end of tradesignal identification-------------------+  

	TradeSettings();//gets customized order settings 
	
//+----TradeWave code-----lot sizing calculated from previous trade---------------+
//+----adjusts lot size for current position based on the previous trade being a winner or loser
	equity = AccountEquity();
	double PreviousEquity = GetPastEquity(1);

        if( PreviousEquity != -1 && equity > PreviousEquity )//Manipulates lot size to maximize equity growth from multiple consecutive winning positions
	      	{
	      	Print("first...ILots: ",ILots,"    Lots: ",Lots,"  AccountFreeMargin: ",AccountFreeMargin());	
 	        ILots = Lots;
 		Lots = NormalizeDouble(AccountFreeMargin()/(LotIncreaseFactor*1000/0.1),1);
                if(Lots < 0.01) Lots = 0.01;
                if(Lots > 99) Lots = 99;
                Print("second...ILots: ",ILots,"    Lots: ",Lots,"  AccountFreeMargin: ",AccountFreeMargin());
                }
                else
                {
                ILots = Lots;
                }
//+--------lot adjustments if the last trade lost-------+
	if( PreviousEquity != -1 && equity <= PreviousEquity )//Manipulates lot size to reduce equity drawdown from multiple consecutive losing positions
		    {
		//	Print("Previous Loser TradeWave  Equity=",equity,"  <=  PreviousEquity=",PreviousEquity,"   Lots = ",Lots);
			Lots = 0.01;    //very effective at reducing drawdown but impacts gains negatively as well   
		//	Print("XXXXXXXXXXXx  Equity=",equity,"  <=  PreviousEquity=",PreviousEquity,"   Lots = ",Lots);
		    }
		    else
		    {
		//	Print("Order NUMBER: ",OrderTicket()+1,"  H=",highMatches," L=",lowMatches," Lots After Matching loser default & Before Wave Change =",Lots);  
			Lots = Lots;
		//	Print("Order NUMBER: ",OrderTicket()+1, "  .....................loser default Lots After Wave Change=",Lots);
		//	FirstSignalInSeries = False;
		    }       
            
                
//+----end of TradeWave code-----lot sizing calculated from previous trade---------------+
        Print("ILots: ",ILots,"    Lots: ",Lots);
//+-----------------Stop Loss and Take Profit Order code----------------------------+
	if (StopLossMode) //if used sets levels for order stop loss
	{
	    StopLossLevel = Ask - StopLoss * Point; 
	}
	else 
	{
	    StopLossLevel = 0.0; 
	}
	if (TakeProfitMode) //if used sets levels for order take profit
	{
	    TakeProfitLevel = Ask + TakeProfit * Point; 
	}
	else 
	{
	    TakeProfitLevel = 0.0; 
	}

//+-------------End Stop Loss and Take Profit Order code----------------------------+ 


//stoptrailgap =  StopLoss*Point - Point*TrailingStop;
//if(stoptrailgap > 0)
//      {
//      if(Bid < OrderOpenPrice - stoptrailgap)//going below engagement level activates trailing stop
//                {
//                LowTrailingStopTrigger = True;
//                }
//      if( LowTrailingStopTrigger )
//              {
//              OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
//              }


	
//+----------Place Order code------------------------------------------------------------+    
//	     
        bool FirstOrderInSeries = True;
	for (int o = 0; o < MaxOpenTrade; o ++)
	{
	    //Print("after (for) before ct ",CountTrades()," < maxopen ",MaxOpenTrade, "     (ticket) = ",Ticket,"  ", Symbol(),"  ",OP_BUY,"  ",Lots,"  ",Ask,"  ",Slippage,"  ",StopLossLevel,"  ",TakeProfitLevel,"  ",MagicNumber);
	    if(CountTrades() < MaxOpenTrade)//allows multiple trades on signal
	    {
		//Print("after ct<mot before (place order) = ",PlaceOrder,"  ", "(ticket) = ",Ticket,"  ", Symbol(),"  ",OP_BUY,"  ",Lots,"  ",Ask,"  ",Slippage,"  ",StopLossLevel,"  ",TakeProfitLevel,"  ",MagicNumber);
		if(PlaceOrder)//allows or disallows orders to open based on signal matching
		{	  
		      Print("after (place order) = ",PlaceOrder," before              (ticket) = ",Ticket,"  ",  Symbol(),"  ",OP_BUY,"  ",Lots,"  ",Ask,"  ",Slippage,"  ",StopLossLevel,"  ",TakeProfitLevel,"  ",MagicNumber);
		      Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
	              Print("after Ticket................................(ticket) = ",Ticket,"  ",  Symbol(),"  ",OP_BUY,"  ",Lots,"  ",Ask,"  ",Slippage,"  ",StopLossLevel,"  ",TakeProfitLevel,"  ",MagicNumber);
	              if(FirstOrderInSeries == True) //stores HIGH and LOW values only once if trade or trade series is opened 
		            {
	                     StoreHighsAndLows(HIGH,LOW);
	                     StoreAccountEquity(equity);
	                     FirstOrderInSeries = False;
Print("OrderOpenPrice: ",OrderOpenPrice(),"  Ask: ",Ask,"  Bid: ",Bid,"  Spread: ", (MarketInfo(OrderSymbol(),MODE_SPREAD))*0.0001,"  SL: ", StopLoss*Point,"  OrderStopLoss: ",OrderStopLoss(),"  TS: ", Point*TrailingStop,"  stoptrailgap: ",stoptrailgap);	                     
	                     }
	        }
		else
		{
		      if(FirstOrderInSeries == True) //stores HIGH and LOW values only once if trade or trade series is opened 
		            {
                             StoreHighsAndLows(HIGH,LOW);
	                     StoreAccountEquity(equity);
	                     Print("order disallowed by matching signal");
	                     FirstOrderInSeries = False;
	                     }
	        }
	      	if(Ticket > 0) 
		{        
		    if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
		    {
		        Print("AFTERORDER: ",OrderTicket()+1,  Symbol(),"  ",OP_BUY,"  ",Lots,"  ",Ask,"  ",Slippage,"  ",StopLossLevel,"  ",TakeProfitLevel,"  ",MagicNumber,"   TS: ",TradeSignal,"   H = ",highMatches," L = ",lowMatches,"    ILots: ",ILots,"  Eq w/l= ",equity-PreviousEquity,"  AccountFreeMargin = ",AccountFreeMargin(),"  Lots: ",Lots,"  ticket: ",Ticket);//test feedback journal output		
	            }
		    if (SignalMail) 
		    {
			SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			return(0);
		    }
		} 
		else 
		{
		if(Ticket == 0 && FirstOrderInSeries == True)
		        {
                         int err;
                         err=GetLastError();
                         Print("Order Number: ",OrderTicket() ,"  Lots: ",Lots,"  error(",err,"): ",ErrorDescription(err));
                         return(0);
                        }    
		}
            }
        }                     	       	    
	if (EachTickMode) 
	{
	    TickCheck = True;
	}
	if (!EachTickMode) 
	{
	    BarCount = Bars;
	}		    
//+---------End of Place Order code------------------------------------------------------------+
    }//----end of:  if (Order == SIGNAL_BUY...

    return(0);
}//----end of:  int start()

//+------------------------------------------------------------------+
//|End of expert start function                                      |
//+------------------------------------------------------------------+

//+------------------trailing stop OrderModify-------thanks Maji-----+
int ModifyTrades() 
{ 
    stoptrailgap =  StopLoss*Point - Point*TrailingStop;    
    int trade=0; 
    for(trade=OrdersTotal()-1;trade>=0;trade--) 
    { 
	OrderSelect(trade,SELECT_BY_POS,MODE_TRADES); 
	if(OrderSymbol()!=Symbol()&&OrderMagicNumber()!=MagicNumber) 
	    continue; 

	if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
	{ 
	    if(TrailingStopMode && TrailingStop > 0) 
	    {    
	               if(Bid < OrderOpenPrice() - stoptrailgap)//going below engagement level activates trailing stop
                       {
                          LowTrailingStopTrigger = True;
                       }      
		       if(LowTrailingStopTrigger == True || Bid - OrderOpenPrice() > Point * TrailingStop || OrderOpenPrice() - Bid >= 0) //lowtrailingstop is triggered || current value of position is > trailing stop price || position now has more value than when it opened
		           { 
		           if( OrderStopLoss() < Bid - Point * TrailingStop || OrderStopLoss() == 0) // lowtrailingstop is triggered || current stop loss is lower (farther away for long position) than the trailing stop param || current stop loss doesn't exist
		                 { 
			          OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
		          
		                 }
		           }
		           
	    }
	}
    }  
}   
//+-----------------------end of trailing stop modify----------------+

//+--------------Trade settings function-----------------------------+
//+--------------Customizes order settings---------------------------+
void TradeSettings()
{
    if(TradeSignal==1)
    {     
	TakeProfit=TakeProfit1;
	StopLoss=StopLoss1;
	Lots=Lots1;
	MinsMultiplier=MinsMultiplier1;//10=6165k,60=24192k,70=27288,73=28296,74=27945, 75=29700k 76=29574,77=29312,80=29214,89=29079,90=28197k,91=27729,95=27324k,100=27882k, 120,200,500,700,1000=27540
	StopLossMode = True;//false=7533,true=29700k
	MaxOpenTrade=MaxOpenTrade_1;
    }
    if(TradeSignal==5)
    {      
	TakeProfit=TakeProfit5;
	StopLoss=StopLoss5;
	Lots=Lots5;
	MinsMultiplier=MinsMultiplier5;
	MaxOpenTrade=MaxOpenTrade_5;  
    }
    if(TradeSignal==6)
    {      
	TakeProfit=TakeProfit6;
	StopLoss=StopLoss6;
	Lots=Lots6;
	MinsMultiplier=MinsMultiplier6;
	MaxOpenTrade=MaxOpenTrade_6; 
    }
    if(TradeSignal==7)
    {
	TakeProfit=TakeProfit7;
	StopLoss=StopLoss7;
	Lots=Lots7;
	MinsMultiplier=MinsMultiplier7;
	MaxOpenTrade=MaxOpenTrade_7;  
    }
}    